SystemOrganization addCategory: #ConfigurationOfSqueakFS!

Object subclass: #ConfigurationOfSqueakFS
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSqueakFS'!

!ConfigurationOfSqueakFS class methodsFor: 'development support' stamp: 'tfel 3/8/2012 15:54:15.684'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSqueakFS class methodsFor: 'private' stamp: 'tfel 3/8/2012 15:54:15.705'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSqueakFS class methodsFor: 'private' stamp: 'tfel 3/8/2012 15:54:15.715'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSqueakFS class methodsFor: 'private' stamp: 'tfel 3/8/2012 15:54:15.725'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSqueakFS class methodsFor: 'metacello tool support' stamp: 'tfel 3/8/2012 15:54:15.736'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSqueakFS class methodsFor: 'loading' stamp: 'tfel 3/8/2012 15:54:15.746'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSqueakFS class methodsFor: 'loading' stamp: 'tfel 3/8/2012 15:54:15.755'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSqueakFS class methodsFor: 'loading' stamp: 'tfel 3/8/2012 15:54:15.766'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSqueakFS class methodsFor: 'accessing' stamp: 'tfel 3/8/2012 15:54:15.776'!
project

	^self new project! !

!ConfigurationOfSqueakFS class methodsFor: 'development support' stamp: 'tfel 3/8/2012 15:54:15.694'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSqueakFS methodsFor: 'baselines' stamp: 'tfel 3/8/2012 15:55:29.584'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/SqueakFS'.
		spec package: 'SqueakFS' with: [spec requires: #('RatPack')].
		spec project: 'RatPack' with: [
				spec
					className: 'ConfigurationOfRatPack';
					file: 'ConfigurationOfRatPack';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec group: 'default' with: #('SqueakFS' ). ].
! !

!ConfigurationOfSqueakFS methodsFor: 'symbolic versions' stamp: 'tfel 3/8/2012 15:54:15.809'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfSqueakFS methodsFor: 'accessing' stamp: 'tfel 3/8/2012 15:54:15.672'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSqueakFS methodsFor: 'versions' stamp: 'tfel 3/8/2012 15:55:47.063'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'tfel'.
		spec timestamp: '3/8/2012 15:54'.
		spec project: 'RatPack' with: '1.0'.
		spec package: 'SqueakFS' with: 'SqueakFS-tfel.1'. ].
! !
